Class MMCmut expands Mutator config(ModMenuChecker_v120);

var config bool bLogModMenus;
var config bool bLogPlayerInfo;
var config bool bExtendedInfo;

var config string MMCAdminPass,MMCAdminName;

struct PlayerInfo
{
	var PlayerPawn PP;
	var string mods[256], prefix[256];
	var int modcount, logincount;
	var bool bInfoLogged, bAdmin;
};

var PlayerInfo PI[64];

function Mutate(string MutateString, PlayerPawn Sender)
{
	local string mod, prefix;
	local int i,j,spacepos;
	local string SkinName, FaceName;

	Super.Mutate(MutateString,Sender);

	spacepos = InStr(MutateString," ");

	if (spacepos != -1)
	{
		if ((InStr(MutateString,".") != -1) && (InStr(MutateString,"ini:") == -1))
		{
			if ( (InStr(MutateString,"0") == (len(MutateString)-1)) || (InStr(MutateString,"1") == (len(MutateString)-1)) )
			{
				mod = mid(MutateString,spacepos+1,len(MutateString)-spacepos-3);
				prefix = left(MutateString,3);

				PI[Sender.PlayerReplicationInfo.PlayerID].PP = Sender;
				PI[Sender.PlayerReplicationInfo.PlayerID].mods[PI[Sender.PlayerReplicationInfo.PlayerID].modcount] = mod;
				PI[Sender.PlayerReplicationInfo.PlayerID].prefix[PI[Sender.PlayerReplicationInfo.PlayerID].modcount] = prefix;
				PI[Sender.PlayerReplicationInfo.PlayerID].modcount++;

				if (bLogPlayerInfo && !PI[Sender.PlayerReplicationInfo.PlayerID].bInfoLogged)
				{
					if (bExtendedInfo)
					{
						i = Sender.PlayerReplicationInfo.PlayerID;
						if(PI[i].PP.Skin == None)
						{
							PI[i].PP.static.GetMultiSkin(PI[i].PP, SkinName, FaceName);
						}
						else
						{
							SkinName = string(PI[i].PP.Skin);
							FaceName = "None";
						}

							Log("-----------------------------------------------",'MMCv120');
							Log("[MMC] : "$PI[i].PP.PlayerReplicationInfo.PlayerName,'MMCv120');
							Log("-----------------------------------------------",'MMCv120');
							Log("[MMC] ID: "$PI[i].PP.PlayerReplicationInfo.PlayerID,'MMCv120');
							Log("[MMC] IP: "$PI[i].PP.GetPlayerNetworkAddress(),'MMCv120');
							Log("[MMC] Netspeed: "$PI[i].PP.Player.CurrentNetSpeed,'MMCv120');
							Log("[MMC] FOV: "$PI[i].PP.FovAngle,'MMCv120');
							Log("[MMC] Voice type: "$PI[i].PP.VoiceType,'MMCv120');
							Log("[MMC] Skin: "$SkinName,'MMCv120');
							Log("[MMC] Face: "$FaceName,'MMCv120');
					}
					else
					{
						log("[MMC] : PlayerJoin:"@Sender.PlayerReplicationInfo.PlayerName@"IP :"@IPOnly(Sender.GetPlayerNetworkAddress()),'MMCv120');
					}
					PI[Sender.PlayerReplicationInfo.PlayerID].bInfoLogged=True;
				}

				if (bLogModMenus)
				{
					log("[MMC] :"@Sender.PlayerReplicationInfo.PlayerName@"("$prefix$")"@mod,'MMCv120');
				}
			}
		}
	}

	if (caps(left(MutateString,3)) == "MMC")
	{
		if (InStr(caps(MutateString),"LOGIN") != -1)
		{
			if (mid(MutateString,10,len(MMCAdminName)+len(MMCAdminPass)+1) == (MMCAdminName@MMCAdminPass))
			{
				PI[Sender.PlayerReplicationInfo.PlayerID].bAdmin=True;
				Sender.ClientMessage("you are now MMC admin");
			}
			else
			{
				PI[Sender.PlayerReplicationInfo.PlayerID].logincount++;
				if (PI[Sender.PlayerReplicationInfo.PlayerID].logincount > 3)
				{
					BroadCastMessage("KICK :"@Sender.PlayerReplicationInfo.PlayerName@"(incorrect login/pass x4)");
					log("KICK :"@Sender.PlayerReplicationInfo.PlayerName@"(incorrect login/pass x3)",'MMCv120');
					Sender.Destroy();
				}
			}
		}

		if (Instr(caps(MutateString),"SHOWMODMENUS") != -1)
		{
			if ( PI[Sender.PlayerReplicationInfo.PlayerID].bAdmin || Sender.bAdmin)
			{
				for(i=0;i<64;i++)
				{
					if (PI[i].PP != None)
					{
						Sender.ClientMessage("---------------------------------------------");
						Sender.ClientMessage("[MMC] :"@PI[i].PP.PlayerReplicationInfo.PlayerName@"("$PI[i].modcount$")");
						Sender.ClientMessage("---------------------------------------------");
						for(j=0;j<PI[i].modcount;j++)
						{
							if (PI[i].mods[j] != "")
							{
								Sender.ClientMessage("("$PI[i].prefix[j]$")"@PI[i].mods[j]);
							}
						}

					}
				}
			}
		}

		if ( (Instr(caps(MutateString),"SHOWMODMENU") != -1) && (Instr(caps(MutateString),"SHOWMODMENUS") == -1) )
		{
			if ( PI[Sender.PlayerReplicationInfo.PlayerID].bAdmin || Sender.bAdmin)
			{
				i = int(mid(MutateString,Instr(caps(MutateString),"SHOWMODMENU")+12,1));
				if (PI[i].PP != None)
				{
					Sender.ClientMessage("---------------------------------------------");
					Sender.ClientMessage("[MMC] :"@PI[i].PP.PlayerReplicationInfo.PlayerName@"("$PI[i].modcount$")");
					Sender.ClientMessage("---------------------------------------------");
					for(j=0;j<PI[i].modcount;j++)
					{
						if (PI[i].mods[j] != "")
						{
							Sender.ClientMessage("("$PI[i].prefix[j]$")"@PI[i].mods[j]);
						}
					}
				}
			}
		}

		if (Instr(caps(MutateString),"SHOWPLAYERINFO") != -1)
		{
			if ( PI[Sender.PlayerReplicationInfo.PlayerID].bAdmin || Sender.bAdmin)
			{
				if (bExtendedInfo)
				{
					for(i=0;i<64;i++)
					{
						if (PI[i].PP != None)
						{
							if(PI[i].PP.Skin == None)
							{
								PI[i].PP.static.GetMultiSkin(PI[i].PP, SkinName, FaceName);

							}
							else
							{
								SkinName = string(PI[i].PP.Skin);
								FaceName = "None";
							}

							Sender.ClientMessage("-----------------------------------------------");
							Sender.ClientMessage("[MMC] : "$PI[i].PP.PlayerReplicationInfo.PlayerName);
							Sender.ClientMessage("-----------------------------------------------");
							Sender.ClientMessage("ID: "$PI[i].PP.PlayerReplicationInfo.PlayerID);
							Sender.ClientMessage("IP: "$PI[i].PP.GetPlayerNetworkAddress());
							Sender.ClientMessage("Netspeed: "$PI[i].PP.Player.CurrentNetSpeed);
							Sender.ClientMessage("FOV: "$PI[i].PP.FovAngle);
							Sender.ClientMessage("Voice type: "$PI[i].PP.VoiceType);
							Sender.ClientMessage("Skin: "$SkinName);
							Sender.ClientMessage("Face: "$FaceName);
						}
					}
				}
				else
				{
					Sender.ClientMessage("---------------------------------------------");
					Sender.ClientMessage("[MMC] : PlayerInfo");
					Sender.ClientMessage("---------------------------------------------");
					for(i=0;i<64;i++)
					{
						if (PI[i].PP != None)
						{
							Sender.ClientMessage(Sender.PlayerReplicationInfo.PlayerName@IPOnly(Sender.GetPlayerNetworkAddress()));
						}
					}
				}
			}
		}
	}
}


function string IPOnly(string IP)
{
	local int i;

	i = InStr(IP, ":");

	if (i != -1)
		return Left(IP, i);
	else
		return IP;
}

defaultproperties
{
	bHidden=True
}